#include "xbp.ch"
#include "appevent.ch"
#INCLUDE "dcdialog.CH"
#include "foxdbe.ch"
#include "Dbfdbe.ch"
#include "CDxdbe.ch"

#xcommand DEFAULT <param> TO <value> => ;
         <param> := IF(<param> == NIL, <value>, <param>)



function progmain()
******************************************************************
local getlist := {},nLeft := 0
tbcolor("INIT")
@ 1,1         DCPUSHBUTTONXP SIZE 150,150 CAPTIONARRAY wlbcaption(150,150 ,chr(48),"Test 1",,"8.Arial",,)  PIXEL  COLOR GRA_CLR_WHITE,tbcolor("NEXT") DROP {|o,x|testdrop(1,o,x,getlist)}
@ 1,DCGUI_COL DCPUSHBUTTONXP SIZE 150,150 CAPTIONARRAY wlbcaption(150,150 ,chr(48),"Test 2",,"8.Arial",,)  PIXEL  COLOR GRA_CLR_WHITE,tbcolor("NEXT") DROP {|o,x|testdrop(2,o,x,getlist)}
@ 1,DCGUI_COL DCPUSHBUTTONXP SIZE 150,150 CAPTIONARRAY wlbcaption(150,150 ,chr(48),"Test 3",,"8.Arial",,)  PIXEL  COLOR GRA_CLR_WHITE,tbcolor("NEXT") DROP {|o,x|testdrop(3,o,x,getlist)}
@ 1,DCGUI_COL DCPUSHBUTTONXP SIZE 150,150 CAPTIONARRAY wlbcaption(150,150 ,chr(48),"Test 4",,"8.Arial",,)  PIXEL  COLOR GRA_CLR_WHITE,tbcolor("NEXT") DROP {|o,x|testdrop(4,o,x,getlist)}
@ 1,DCGUI_COL DCPUSHBUTTONXP SIZE 150,150 CAPTIONARRAY wlbcaption(150,150 ,chr(48),"Test 5",,"8.Arial",,)  PIXEL  COLOR GRA_CLR_WHITE,tbcolor("NEXT") DROP {|o,x|testdrop(5,o,x,getlist)}
@ 150,1       DCPUSHBUTTONXP SIZE 150,150 CAPTIONARRAY wlbcaption(150,150 ,chr(48),"Test 6",,"8.Arial",,)  PIXEL  COLOR GRA_CLR_WHITE,tbcolor("NEXT") DROP {|o,x|testdrop(6,o,x,getlist)}
@ 1,DCGUI_COL DCPUSHBUTTONXP SIZE 150,150 CAPTIONARRAY wlbcaption(150,150 ,chr(48),"Test 7",,"8.Arial",,)  PIXEL  COLOR GRA_CLR_WHITE,tbcolor("NEXT") DROP {|o,x|testdrop(7,o,x,getlist)}
@ 1,DCGUI_COL DCPUSHBUTTONXP SIZE 150,150 CAPTIONARRAY wlbcaption(150,150 ,chr(48),"Test 8",,"8.Arial",,)  PIXEL  COLOR GRA_CLR_WHITE,tbcolor("NEXT") DROP {|o,x|testdrop(8,o,x,getlist)}
@ 1,DCGUI_COL DCPUSHBUTTONXP SIZE 150,150 CAPTIONARRAY wlbcaption(150,150 ,chr(48),"Test 9",,"8.Arial",,)  PIXEL  COLOR GRA_CLR_WHITE,tbcolor("NEXT") DROP {|o,x|testdrop(9,o,x,getlist)}
@ 1,DCGUI_COL DCPUSHBUTTONXP SIZE 150,150 CAPTIONARRAY wlbcaption(150,150 ,chr(48),"Test 10",,"8.Arial",,)  PIXEL  COLOR GRA_CLR_WHITE,tbcolor("NEXT") DROP {|o,x|testdrop(10,o,x,getlist)}

dcread gui fit modal

return .t.

static function testdrop(o,x,getlist)
******************************************************************
DCQDEBUG x
return .t.


FUNCTION Main ()
******************************************************************

  IF ! DbeLoad( "CDXDBE",.T.)
     Alert( "Database-Engine CDXDBE not loaded" , {"OK"} )
  ENDIF

  IF ! DbeBuild( "DBFCDX", "DBFDBE", "CDXDBE" )
     Alert( "DBFCDX Database-Engine;Could not build engine" , {"OK"} )
  ENDIF

  IF ! DbeLoad( "FOXDBE",.T.)
     Alert( "Database-Engine FOXDBE not loaded" , {"OK"} )
  ENDIF

  IF ! DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
     Alert( "FOXCDX Database-Engine;Could not build engine" , {"OK"} )
  ENDIF
SET COLLATION TO GERMAN


DbeSetDefault("DBFCDX")
DbeInfo(COMPONENT_DATA,  DBFDBE_LOCKRETRY, 1000000)
DbeInfo(COMPONENT_ORDER, CDXDBE_LOCKRETRY, 1000000)
DbeInfo(COMPONENT_ORDER, CDXDBE_LOCKDELAY, 10)

DbeSetDefault("FOXCDX")
DbeInfo(COMPONENT_DATA,  FOXDBE_LOCKRETRY, 1000000)
DbeInfo(COMPONENT_ORDER, CDXDBE_LOCKRETRY, 1000000)
DbeInfo(COMPONENT_ORDER, CDXDBE_LOCKDELAY, 10)


DbeSetDefault("DBFCDX")
SET COLLATION TO GERMAN

DbeInfo( COMPONENT_ORDER, DBE_LOCKMODE, LOCKING_EXTENDED )
DbeInfo(COMPONENT_DATA, FOXDBE_LIFETIME, 1)
progmain()

RETURN nil

/* -------------   DBFDBE_LOCKRETRY       */

PROCEDURE AppSys()

  LOCAL oCrt, nAppType := AppType()

  DO CASE

    CASE .t.

    // PM Mode: create an XbpCrt instance
    CASE nAppType == APPTYPE_PM

      // First active SetAppWindow() == Desktop
      AppDesktop ( SetAppWindow() )

      // Create XbpCRT object
      oCrt := XbpCrt():New ( NIL, NIL, { 0, 0 }, 25, 80 )
      oCrt:FontWidth  := 8
      oCrt:FontHeight := 16
#ifdef __OS2__
      oCrt:FontName   := "System VIO"
#endif
#ifdef __WIN32__
      oCrt:FontName   := "Alaska Crt"
      oCrt:Title      := "C-TEC Softwareentwicklung Rudolf Reinthaler"
#endif
      oCrt:Create()

      // Init Presentation Space
      oCrt:PresSpace()

      // XbpCrt gets active window and output device
      SetAppWindow ( oCrt )

    // VIO or NOVIO Mode: create a RootCrt instance
    CASE nAppType == APPTYPE_VIO .OR. nAppType == APPTYPE_NOVIO

      // Create RootCrt object
      oCrt := RootCrt():New():Create()

      // RootCrt gets active window and output device
      SetAppWindow ( oCrt )

  ENDCASE

RETURN




function tbcolor(cCode)
******************************************************************
static nSeq,aSysColor
LOCAL x,nPos := 1
local aColor :=  {{0,154,172},;  // 1 blau    0 120 215
                 {185,29,71},;   // 2 rot       240 90 88
                 {87,54,177},;   // 3 blauviolett 129 129 191
                 {44,134,238},;  // 4 blau2      gelb: 255 210 223
                 {219,85,45},;   // 5 orange    221 75 57
                 {38,116,236},;  // 6 blau3    85 172 238
                 {0,154,0}  ,;   // 7 grn     103 188 69
                 {164,0,172},;   // 8 violett   128 57 123
                 {9,78,182} }    // 9 dunkelblau 60 90 153

default nSeq to 0
do case
     case cCode = "INIT"
          nSeq := 1
          return aColor[1]
     case cCode = "NEXT"
          nSeq++
          if nSeq > len(aColor)
               nSeq := 1
          endif
          return aColor[nSeq]
     case cCode = "BLUE_BG" .or. cCode = "BASE"
          return COLOR_BASE
     case cCode = "BLUE1"
          return aColor[1]
     case cCode = "BLUE2"
          return aColor[3]
     case cCode = "BLUE3"
          return aColor[4]
     case cCode = "BLUE4"
          return aColor[6]
     case cCode = "GREEN1"
          return aColor[7]
     case cCode = "ORANGE"
          return aColor[5]
     case cCode = "PURPLE"
          return aColor[8]
     case cCode = "BLUE4" .or. cCode = "DARKBLUE"
          return aColor[9]
     case cCode = "RED1"
          return aColor[2]
     case cCode = "BLACK"
          return {0,0,0}
     case cCode = "RANDOM"
          nPos := dc_random(9)
          if nPos < 1
               nPos := 1
          endif
          if nPos > 9
               nPos := 9
          endif
          return aColor[nPos]
     case cCode = "ALL"      // Standardfarben in der richtigen reihenfolge
          return aColor
endcase

return {255,255,255}

//                 1    2    3    4      5      6          7          8        9
FUNCTION wlbcaption(nBX,nBY,cChar,cText,cSFont,cLFont,nSymbolColor,nLabelColor,lPixel)
******************************************************************
local nFS,nLFS
local nTop
local nLeft
default cLFont       to "Arial"
default nSymbolColor to GRA_CLR_WHITE
default nLabelColor  to GRA_CLR_WHITE
default lPixel       to .t.
default cSFont to "Wingdings"
nFS   := int(min(nBX,nBY)/3.5)
nTop  := nBY-12
nLeft := (nBX/2)-(nFS/2)-5
if !"." $ cSFont
     cSFont := ntrim(25) + '.' + cSFont
     *cSFont := ntrim(nFS) + '.' + cSFont
endif
if !"." $ cLFont
     cLFont := ntrim(int(min(nBx,nBy)/6)) + "." + cLFont
endif
return { ;
  {cChar, nSymbolColor,nTop-90,nLeft, , ,                                   ,cSFont,,}, ;
  {cText, nLabelColor ,    ,     , , ,XBPALIGN_BOTTOM + XBPALIGN_HCENTER ,cLFont,,}}

function ntrim(p_string,p_dez,lKomma)
**************************************************************************
default p_dez to 0
DEFAULT lKomma to .f.
if !lKomma
     return alltrim(str(p_string,20,p_dez))
else
     return strtran(alltrim(str(p_string,20,p_dez)),".",",")
endif
return p_string
